/*
* You must call the function findBrowser () to initialize this three variables.
*/
var platformName ;
var browserName ;
var numberVersion ;

/*
* Used to find informations on the browser. The informations are :
* 	   - name of the platform,
*	   - name of the browser,
*	   - number of the version of the navogator.
* The function return Unknown if the plugin can't be supported.
*/
function  findBrowser () {
		  platformName = findPlatformName () ;
		  browserName = findBrowserName () ;
		  numberVersion = findNumberVersionBrowser () ;
		  
		  //alert ("platformName = "+platformName) ;
		  //alert ("browserName = "+browserName) ;
		  //alert ("numberVersion = "+numberVersion) ;
		  var browser = "Unknown" ;
		  		  
		  if (platformName == "Unknown" || browserName == "Unknown" || numberVersion == "NaN") {
		  	 return browser ;
		  }
		  
		  if (browserName == "Netscape") {
		  	 if (platformName == "Windows") {
			 	if (numberVersion >= 4) {
				   	   browser = "Net.Win.4" ;
				}
			 }
		  	 else {
			 	  if (platformName == "Macintosh") {
				  	 if (numberVersion >= 4) {
					 	browser = "Net.Mac.4" ;
					 }
				  }
			 }
		  }
		  
		  else {
		  	   if (browserName == "Explorer") {
			   	  if (platformName == "Windows") {
				  	 if (numberVersion >= 4) {
					 	var version = navigator.appVersion ;
						var index = version.indexOf ("MSIE 5") ;					
					 	//alert ("index ="+ index) ;
						if (index != -1) {
							browser = "Exp.Win.5" ;
						}
					 }
				  }
			   }
		  }

		  return browser ;
}

/*
* Used to find the name of the platform.
* The function can return :
* 	  - Windows,
* 	  - Macintosh,
*	  - Unknown.
* Example for the field navigator.userAgent :
* 		  Mozilla/2.0 (Win16; I). 
*/
function findPlatformName () {
		 var platform = navigator.userAgent ;
		 var indexWin = (platform.toLowerCase ()).indexOf ("win") ;
		 var indexMac = (platform.toLowerCase ()).indexOf ("mac") ;
		 		 
		 if (indexWin != -1 && indexWin != "") {
		 	platformName = "Windows" ;
		 }
		 else {
		 	  if (indexMac != -1 && indexMac != "") {
			  	 platformName = "Macintosh" ;
			  } 
		 	  else {
			  	   platformName = "Unknown" ;
			  }
		 }
		 
		 return platformName ;	
}

/*
* Used to find the name of the browser.
* The function can return :
* 	  - Netscape,
*	  - Explorer,
*	  - Unknown.
* Example for the field navigator.appName :
* 		  Netscape 
*/
function  findBrowserName () {
		  	var browser = navigator.appName.toLowerCase () ;
						
			if (browser == "netscape") {
			   browserName = "Netscape" ;			
			}
			else {
				 if (browser == "microsoft internet explorer") {
				 	browserName = "Explorer" ;
				 }
				 else {
				 	  browserName = "Unknown" ;
				 }
			}	 

			return browserName ;
} 	

/*
* Used to find the number of the version of the navigator.
* if there is a problem the function return NaN (Not a Number).
* Example for the field navigator.appVersion :
* 		  3.0 (WinNT, I)
*/
function findNumberVersionBrowser () {
		 var version = navigator.appVersion ;
		 //alert ("version = "+version)
		 numberVersion = parseFloat (version.substring (0, version.indexOf (" "))) ;
		 return numberVersion ;	
}

	