
function displaySrc(src)
	{
	var spy=window.open("DataSheet.htm",'dataSheet',"width=500;height=300")
	spy.document.open()
	spy.document.write(src)
	spy.document.close()
	}

function max(Data)
	{
	var m=0
	for (i=1;i<Data.length;i++)
		{
		for (j=1;j<Data[i].length;j++)
			{
			if (parseFloat(Data[i][j])>m) {
			   m=parseFloat(Data[i][j])}
			}
		}
	return m
	}

function reDraw()
	{
	repLength=3
	
	chartCenterX=(chartData[0].length-2)/2
	chartCenterZ=(chartData.length-2)/2
	
	factorX=1/(chartData[0].length-1)
	factorY=1/max(chartData)
	factorZ=1/(chartData.length-1)
	
	for (plotLine=1;plotLine<chartData.length-1;plotLine++)
	//for (plotLine=1;plotLine<3;plotLine++)
		{
		ID="L_"+plotLine
		text=chartData[plotLine][0]
		X=-(chartCenterX*style.chart.width*factorX)-style.legend.Z.offset
		Y=0
		Z=(plotLine-1-chartCenterZ)*style.chart.depth*factorZ
		addLegend(ID,text,X.toString(),Y.toString(),Z.toString(),'Z')
		
		for (plotCol=1;plotCol<chartData[plotLine].length;plotCol++)
		//for (plotCol=1;plotCol<2;plotCol++)  
			{
			if (plotLine==1)
				{
				ID="C_"+plotCol
				text=chartData[0][plotCol]
				X=(plotCol-1-chartCenterX)*style.chart.width*factorX
				Y=0
				Z=(chartCenterZ*style.chart.depth*factorZ)+style.legend.X.offset
				addLegend(ID,text,X.toString(),Y.toString(),Z.toString(),'X')
				}
				
			X=(plotCol-1-chartCenterX)*style.chart.width*factorX
			Y=chartData[plotLine][plotCol]*style.chart.height*factorY
			Z=(plotLine-1-chartCenterZ)*style.chart.depth*factorZ
			
			ID="PLOT_L"+plotLine+"_C"+plotCol
			add_spot(ID,X.toString(),Y.toString(),Z.toString(),plotLine,plotCol)
			}
		}
	}

function rotateLegend(theta,phi)
	{
	for (i=1;i<chartData.length;i++)
		{
		NodeID="Legend_" + "L_"+ i
		TSUpdateNodeAttribute(NodeID,'rotation',phi.toString()+' '+theta.toString()+' 0')
		}
	for (j=1;j<chartData[0].length;j++)
		{
		NodeID="Legend_" + "C_"+ j
		TSUpdateNodeAttribute(NodeID,'rotation',phi.toString()+' '+theta.toString()+' 0')
		}
	}
	
function addLegend(ID,text,X,Y,Z,axe)
	{
	var legendID = 'Legend_' + ID
	TSCreateNode('SolidPointLight',legendID);
	TSSetAttribute(legendID,'fixed',			'1')
	TSSetAttribute(legendID,'position',		X + ' ' + Y + ' ' + Z)
	TSSetAttribute(legendID,'color',		style.legend[axe].color)
	TSSetAttribute(legendID,'state',		'0')
	TSAppendChild(TSGetSceneId(),legendID);

	var legendMouseOverID = 'LegendMouseOver_' + ID
	TSCreateNode('UserEvent',legendMouseOverID);	
	TSSetAttribute(legendMouseOverID,'eventType','mouse_over')
	TSSetAttribute(legendMouseOverID,'handler','hiLight')
	
	var legendMouseOutID = 'LegendMouseOut_' + ID
	TSCreateNode('UserEvent',legendMouseOutID);	
	TSSetAttribute(legendMouseOutID,'eventType','mouse_out')
	TSSetAttribute(legendMouseOutID,'handler','unLight')
	
	var legendGeomID = 'LegendGeom_' + ID
	TSCreateNode('GeomText',legendGeomID);	
	TSSetAttribute(legendGeomID,'fixed','1')
	TSSetAttribute(legendGeomID,'text',text)
	//TSSetAttribute(legendGeomID,'font',style.legend[axe].fontFace.toString())
	TSSetAttribute(legendGeomID,'font','Arial')
	TSSetAttribute(legendGeomID,'size',style.legend[axe].fontSize.toString())
	//TSSetAttribute(legendGeomID,'bold',style.legend[axe].fontBold.toString())
	TSSetAttribute(legendGeomID,'bold','0')
	//TSSetAttribute(legendGeomID,'italic',style.legend[axe].fontItalic.toString())
	TSSetAttribute(legendGeomID,'italic','0')
	TSSetAttribute(legendGeomID,'color',style.legend[axe].color.toString())
	TSSetAttribute(legendGeomID,'thickness',style.legend[axe].thickness.toString())
	TSSetAttribute(legendGeomID,'material',style.legend[axe].phong+' '+style.legend[axe].phongSize+' '+style.legend[axe].alpha)
	TSAppendChild(legendID,legendGeomID)

	var legendRefMapID = 'LegendRefMap_' + ID
	TSCreateNode('EnvMap',legendRefMapID);	
	TSSetAttribute(legendRefMapID,'url',style.legend[axe].refMap)
	TSSetAttribute(legendRefMapID,'transparency',style.legend[axe].reflection.toString())

	if (style.legend[axe].reflection!=0) {
		TSAppendChild(legendGeomID,legendRefMapID)
	}

	//TSAppendChild(legendID,legendGeomID)
	//TSAppendChild(TSGetSceneId(),legendID);	

	TSUpdateNode(legendID)
	}
	
function hiLight(obj,event)
	{
	TSUpdateNodeAttribute(obj,"state","1")
	self.document.all.ToolBar.document.all.notes.innerText=TSGetExtraParam(event,"value");
	}
	
function unLight(obj,event)
	{
	if (obj != null) 
	   TSUpdateNodeAttribute(obj,"state","0")
	self.document.all.ToolBar.document.all.notes.innerText="Use arrow keys to rotate. Mouse over items to see the value. Click to edit."
	}
	
function add_spot(ID,X,Y,Z,plotLine,plotCol)
	{
	var repID = 'Rep_' + ID
	TSCreateNode('Solid',repID)
	TSSetAttribute(repID,'fixed','1')
	TSSetAttribute(repID,'position',X + ' 0 ' + Z)
	
	
	var repGeomID = 'RepGeom_' + ID
	TSCreateNode('GeomBlock',repGeomID)
	TSSetAttribute(repGeomID,'lengthX',style.repere.width.toString())
	TSSetAttribute(repGeomID,'lengthY','0.01')
	TSSetAttribute(repGeomID,'lengthZ',style.repere.depth.toString())
	TSSetAttribute(repGeomID,'color',style.repere.color)
	TSSetAttribute(repGeomID,'material',style.repere.phong+' '+style.repere.phongSize+' '+style.repere.alpha)
	
	TSAppendChild(repID,repGeomID)
	
	var repGeomRefMapID = 'RepGeomRefMap_' + ID
	TSCreateNode('EnvMap',repGeomRefMapID)
	TSSetAttribute(repGeomRefMapID,'url',style.repere.refMap)
	TSSetAttribute(repGeomRefMapID,'transparency',style.repere.reflection.toString())

	TSAppendChild(repGeomID,repGeomRefMapID)
	
	var spotNodeID = 'Spot_' + ID
	TSCreateNode('SolidSpotLight',spotNodeID)
	TSSetAttribute(spotNodeID,'fixed','1')
	TSSetAttribute(spotNodeID,'position',X + ' ' + Y/2 + ' ' + Z)
	TSSetAttribute(spotNodeID,'direction','0 -1 0')
	TSSetAttribute(spotNodeID,'color',style.col.color)
	TSSetAttribute(spotNodeID,'mass','0.1')
	TSSetAttribute(spotNodeID,'state','0')
	
	var spotActionID = 'LegendAction_' + ID
	TSCreateNode('UserEvent',spotActionID)
	TSSetAttribute(spotActionID,'eventType','left_click_down')
	TSSetAttribute(spotActionID,'handler','editDataSheet')
	//gPlayer.TSSetExtraParam(spotActionID,"value",plotLine+','+plotCol);
	
	var spotMouseOverID = 'SpotMouseOver_' + ID
	TSCreateNode('UserEvent',spotMouseOverID)
	TSSetAttribute(spotMouseOverID,'eventType','mouse_over')
	TSSetAttribute(spotMouseOverID,'handler','hiLight')
	//gPlayer.TSSetExtraParam(spotMouseOverID,"value","CurrentValue: "+chartData[plotLine][plotCol]+" (click to edit) ");
	
	var spotMouseOutID = 'SpotMouseOut_' + ID
	TSCreateNode('UserEvent',spotMouseOutID)
	TSSetAttribute(spotMouseOutID,'eventType','mouse_out')
	TSSetAttribute(spotMouseOutID,'handler','unLight')
	
	var spotGeomID = 'SpotGeom_' + ID
	TSCreateNode('GeomBlock',spotGeomID)
	TSSetAttribute(spotGeomID,'lengthX',style.col.width.toString())
	TSSetAttribute(spotGeomID,'lengthY',Y)
	TSSetAttribute(spotGeomID,'lengthZ',style.col.depth.toString())
	TSSetAttribute(spotGeomID,'material',style.col.phong+' '+style.col.phongSize+' '+style.col.alpha)
	TSSetAttribute(spotGeomID,'color',style.col.color)
	
	var spotGeomRefMapID = 'SpotGeomRefMap_' + ID
	TSCreateNode('EnvMap',spotGeomRefMapID)
	TSSetAttribute(spotGeomRefMapID,'url',style.col.refMap)
	TSSetAttribute(spotGeomRefMapID,'transparency',style.col.reflection.toString())
	
	if (style.col.reflection!=0) {
		TSAppendChild(spotGeomID,spotGeomRefMapID)
	}
	
	TSAppendChild(spotNodeID,spotGeomID)
	TSAppendChild(spotNodeID,spotActionID)
	TSAppendChild(spotNodeID,spotMouseOverID)
	TSAppendChild(spotNodeID,spotMouseOutID)
	
	TSAppendChild(TSGetSceneId(),spotNodeID);
	TSAppendChild(TSGetSceneId(),repID);
	
	TSSetExtraParam(spotActionID,"value",plotLine+','+plotCol);
	TSSetExtraParam(spotMouseOverID,"value","CurrentValue: "+chartData[plotLine][plotCol]+" (click to edit) ");

	TSUpdateNode(spotNodeID)
	TSUpdateNode(repID)	

/*
	var repID = 'Rep_' + ID
	TSCreateNode('Solid',repID)
	TSSetAttribute(repID,'fixed','1')
	TSSetAttribute(repID,'position',X + ' 0 ' + Z)
	TSAppendChild(TSGetSceneId(),repID);
	
	var repGeomID = 'RepGeom_' + ID
	TSCreateNode('GeomBlock',repGeomID)
	TSSetAttribute(repGeomID,'lengthX',style.repere.width.toString())
	TSSetAttribute(repGeomID,'lengthY','0.01')
	TSSetAttribute(repGeomID,'lengthZ',style.repere.depth.toString())
	TSSetAttribute(repGeomID,'color',style.repere.color)
	TSSetAttribute(repGeomID,'material',style.repere.phong+' '+style.repere.phongSize+' '+style.repere.alpha)
	TSAppendChild(repID,repGeomID)
	
	var repGeomRefMapID = 'RepGeomRefMap_' + ID
	TSCreateNode('EnvMap',repGeomRefMapID)
	TSSetAttribute(repGeomRefMapID,'url',style.repere.refMap)
	TSSetAttribute(repGeomRefMapID,'transparency',style.repere.reflection.toString())
	TSAppendChild(repGeomID,repGeomRefMapID)
	
	var spotNodeID = 'Spot_' + ID
	TSCreateNode('SolidSpotLight',spotNodeID)
	TSSetAttribute(spotNodeID,'fixed','1')
	TSSetAttribute(spotNodeID,'position',X + ' ' + Y/2 + ' ' + Z)
	TSSetAttribute(spotNodeID,'direction','0 -1 0')
	TSSetAttribute(spotNodeID,'color',style.col.color)
	TSSetAttribute(spotNodeID,'mass','0.1')
	TSSetAttribute(spotNodeID,'state','0')
	TSAppendChild(TSGetSceneId(),spotNodeID);

	var spotActionID = 'LegendAction_' + ID
	TSCreateNode('UserEvent',spotActionID)
	TSSetAttribute(spotActionID,'eventType','left_click_down')
	TSSetAttribute(spotActionID,'handler','editDataSheet')
	TSAppendChild(spotNodeID,spotActionID)
	//TSSetExtraParam(spotActionID,"value",plotLine+','+plotCol);
		
	var spotMouseOverID = 'SpotMouseOver_' + ID
	TSCreateNode('UserEvent',spotMouseOverID)
	TSSetAttribute(spotMouseOverID,'eventType','mouse_over')
	TSSetAttribute(spotMouseOverID,'handler','hiLight')
	TSAppendChild(spotNodeID,spotMouseOverID)
	//TSSetExtraParam(spotMouseOverID,"value","CurrentValue: "+chartData[plotLine][plotCol]+" (click to edit) ");
		
	var spotMouseOutID = 'SpotMouseOut_' + ID
	TSCreateNode('UserEvent',spotMouseOutID)
	TSSetAttribute(spotMouseOutID,'eventType','mouse_out')
	TSSetAttribute(spotMouseOutID,'handler','unLight')
	TSAppendChild(spotNodeID,spotMouseOutID)

	var spotGeomID = 'SpotGeom_' + ID
	TSCreateNode('GeomBlock',spotGeomID)
	TSSetAttribute(spotGeomID,'lengthX',style.col.width.toString())
	TSSetAttribute(spotGeomID,'lengthY',Y)
	TSSetAttribute(spotGeomID,'lengthZ',style.col.depth.toString())
	TSSetAttribute(spotGeomID,'material',style.col.phong+' '+style.col.phongSize+' '+style.col.alpha)
	TSSetAttribute(spotGeomID,'color',style.col.color)
	TSAppendChild(spotNodeID,spotGeomID)

	var spotGeomRefMapID = 'SpotGeomRefMap_' + ID
	TSCreateNode('EnvMap',spotGeomRefMapID)
	TSSetAttribute(spotGeomRefMapID,'url',style.col.refMap)
	TSSetAttribute(spotGeomRefMapID,'transparency',style.col.reflection.toString())
	
	if (style.col.reflection!=0) {
		TSAppendChild(spotGeomID,spotGeomRefMapID)
	}	
	
	TSUpdateNode(spotNodeID)
	TSUpdateNode(repID)
	//TSUpdateNode(spotNodeID)
*/
	}