	
function Deg2Rad(AngleDeg){return AngleDeg*Math.PI/180}
function Rad2Deg(AngleRad){return AngleRad*180/Math.PI}

function Point(x, y, z)
{
  this.x = x
  this.y = y
  this.z = z
}

function makePoint(x, y, z)
{
  return new Point(x, y, z)
}

function makePointFromString(str)
{
  strSplit = str.split(" ")
  return new Point(parseFloat(strSplit[0]), parseFloat(strSplit[1]), parseFloat(strSplit[2]))
}

function rotatePointX(pt, angle)
{
  new_x = pt.x
  new_y = (pt.y * Math.cos(angle)) + (pt.z * Math.sin(angle))
  new_z = (pt.z * Math.cos(angle)) - (pt.y * Math.sin(angle))

  return new Point(new_x, new_y, new_z)
}

function rotatePointY(pt, angle)
{
  new_x = (pt.x * Math.cos(angle)) - (pt.z * Math.sin(angle))
  new_y = pt.y
  new_z = (pt.x * Math.sin(angle)) + (pt.z * Math.cos(angle))

  return new Point(new_x, new_y, new_z)
}

function rotatePointZ(pt, angle)
{
  new_x = (pt.x * Math.cos(angle)) + (pt.y * Math.sin(angle))
  new_y = (pt.y * Math.cos(angle)) - (pt.x * Math.sin(angle))
  new_z = pt.z

  return new Point(new_x, new_y, new_z)
}
function sphericalRotatePoint(theta, phi)
{
	new_x=Math.cos(phi)* Math.sin(theta)
	new_y=Math.sin(phi)
	new_z=Math.cos(phi)* Math.cos(theta)

    return new Point(new_x, new_y, new_z)
}
function translatePoint(pt, x, y, z) {return new Point(pt.x + x, pt.y + y, pt.z + z)}

function scalePoint(pt, x, y, z) {return new Point(pt.x * x, pt.y * y, pt.z * z)}

function distancePoint(pt1,pt2)
{
	x=pt2.x-pt1.x
	y=pt2.y-pt1.y
	z=pt2.z-pt1.z
	return Math.sqrt((x*x)+(y*y)+(z*z))
}