//------------------------------------------------------
// Lib's - SyB - Last Update : 24/03/2000
//------------------------------------------------------


function Add_Text(xmlObj,ID,Text,Position,Fixed,Style)
	{
	
	var SolidNode=xmlObj.createNode(1,'Solid','x-schema:Schemas.xml')
	TSSetAttribute('id',ID)
	TSSetAttribute('fixed',Fixed)
	TSSetAttribute('position',Position)
	TSSetAttribute('stiffness','1')
	TSSetAttribute('angularVelocity','0 0 0')
	
	var GeomNode=xmlObj.createNode(1,'GeomText','x-schema:Schemas.xml')
	GeomNode.setAttribute('id','Geom_' + ID)
	GeomNode.setAttribute('text',Text)
	GeomNode.setAttribute('font',Style.font)
	GeomNode.setAttribute('bold',Style.bold)
	GeomNode.setAttribute('italic',Style.italic)
	GeomNode.setAttribute('color',Style.color)
	
	var VolNode=xmlObj.createNode(1,'VolBounding','x-schema:Schemas.xml')
	VolNode.setAttribute('id','Vol_' + ID)
	
	SolidNode.appendChild(GeomNode)
	SolidNode.appendChild(VolNode)
	
	xmlDoc=xmlObj.documentElement
	xmlDoc.appendChild(SolidNode)
	
	myobj.UpdateXMLNode(ID)
	}

function Add_Text2(xmlObj, ID, Text, Position, Fixed, Style, Size, Thickness)
	{
	
	var SolidNode=xmlObj.createNode(1,'Solid','x-schema:Schemas.xml')
	TSSetAttribute('id',ID)
	TSSetAttribute('fixed',Fixed)
	TSSetAttribute('position',Position)
	TSSetAttribute('stiffness','1')
	TSSetAttribute('angularVelocity','0 0 0')
	
	var GeomNode=xmlObj.createNode(1,'GeomText','x-schema:Schemas.xml')
	GeomNode.setAttribute('id','Geom_' + ID)
	GeomNode.setAttribute('text',Text)
	GeomNode.setAttribute('font',Style.font)
	GeomNode.setAttribute('bold',Style.bold)
	GeomNode.setAttribute('italic',Style.italic)
	GeomNode.setAttribute('color',Style.color)
	GeomNode.setAttribute('size',Size)
	GeomNode.setAttribute('material','0.7 0.5 0.7')
	GeomNode.setAttribute('thickness',Thickness)
	
	var VolNode=xmlObj.createNode(1,'VolBounding','x-schema:Schemas.xml')
	VolNode.setAttribute('id','Vol_' + ID)
	
	SolidNode.appendChild(GeomNode)
	SolidNode.appendChild(VolNode)
	
	xmlDoc=xmlObj.documentElement
	xmlDoc.appendChild(SolidNode)
	
	myobj.UpdateXMLNode(ID )
	}

function AddText(obj,event)
	{
	var xmlObj=document.all('scene')
	var EventNode=xmlObj.nodeFromID(event)
	var ID=EventNode.selectSingleNode("ExtraParam[@name='ID']").text
	var Text=EventNode.selectSingleNode("ExtraParam[@name='text']").text
	var Position=EventNode.selectSingleNode("ExtraParam[@name='position']").text
	var Size=EventNode.selectSingleNode("ExtraParam[@name='size']").text
	var Thickness=EventNode.selectSingleNode("ExtraParam[@name='thickness']").text
	var Style=EventNode.selectSingleNode("ExtraParam[@name='style']").text
	Add_Text2(xmlObj,ID,Text,Position,'0',TextStyles[Style], Size, Thickness)
}
